#include <windows.h>
#include <psapi.h>
#include <stdio.h>

// user defined constants
#define MAX_PROCESSES 1024

// user defined types

enum m_Modes { M_NUMERIC, M_NAME };

// user defined variables

enum m_Modes enMode;

BOOL init_variables(int argc, char **argv)
{
	if (argc <= 1) { enMode = M_NUMERIC; }
	else { enMode = M_NAME; };
	return TRUE;
}

void show_usage()
{
	return;
}

void PrintProcessNameAndID( DWORD processID )
{
    char szProcessName[MAX_PATH] = "unknown";

    // Get a handle to the process.

    HANDLE hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, processID);

    // Get the process name.

    if (hProcess)
    {
        HMODULE hMod;
        DWORD cbNeeded;

        if (EnumProcessModules(hProcess, &hMod, sizeof(hMod), &cbNeeded))
        {
			GetModuleBaseName(hProcess, hMod, szProcessName, sizeof(szProcessName));
        }
    }

    // Print the process name and identifier.

	if (enMode == M_NUMERIC)
	{
		printf("%6d ---------- %s\n", processID, szProcessName);
	}
	else if (enMode == M_NAME)
	{
		printf("%s ---------- %u\n", szProcessName, processID);
	};

    CloseHandle( hProcess );
}

void show_processes()
{
	// get the list of process identifiers
	DWORD aProcesses[MAX_PROCESSES], cbNeeded, cProcesses;
	unsigned int i;

    if (!EnumProcesses(aProcesses, sizeof(aProcesses), &cbNeeded))
        return;

    // calculate how many process identifiers were returned.

    cProcesses = cbNeeded / sizeof(DWORD);

    // print the name and process identifier for each process.

    for (i = 0; i < cProcesses; i++)
        PrintProcessNameAndID(aProcesses[i]);
}

void main(int argc, char **argv)
{
	if (!init_variables(argc, argv))
	{
		show_usage();
		return;
	};

	show_processes();

	return;
}
