#include <windows.h>
#include <winbase.h>
#include <stdio.h>
#include <time.h>

#define MAX_BUFFER_SIZE 250

 // variables

 LPSTR lpszUserName;
 LPSTR lpszDomainName;
 LPSTR lpszPassword;
 DWORD dwCount;
 DWORD dwLogonType;
 DWORD dwLogonProvider;
 PHANDLE phToken;

 // init variables from command line
BOOL init_variables(int argc, char **argv)
{
	// check for correct number of arguments
	if (argc < 4) { return FALSE; };

	// set username
	lpszUserName = new char[MAX_BUFFER_SIZE];
	wsprintf(lpszUserName, "%s", argv[1]);

	// set password
	lpszPassword = new char[MAX_BUFFER_SIZE];
	wsprintf(lpszPassword, "%s", argv[2]);

	// set domain
	lpszDomainName = new char[MAX_BUFFER_SIZE];
	wsprintf(lpszDomainName, "%s", argv[3]);

	// set dwCount
	sscanf(argv[4], "%d", &dwCount);

	// set logon type
	dwLogonType = LOGON32_LOGON_INTERACTIVE;

	// set logon provider
	dwLogonProvider = LOGON32_PROVIDER_DEFAULT;

	// create the token
	phToken = new HANDLE;

	return TRUE;
}

 // show the usage
BOOL show_help()
{
	printf("usage: xsu.exe <username> <password> <domain> <try_count>");
	return FALSE;
}

 // performs a memory cleanup
void clear_memory()
{
	delete lpszUserName;
	delete lpszPassword;
	delete lpszDomainName;
	delete phToken;
}

 // runs the process
int run_it()
{
	time_t start, end;
	start = time(&start);
	// creates the token
	for (DWORD i = 0; i < dwCount; i++)
	if (!LogonUser(lpszUserName, lpszDomainName, lpszPassword, dwLogonType, dwLogonProvider, phToken))
	{
		printf("\n %d FAILED", i);
	}
	else
	{
		printf("\n %d OK", i);
	};
	end = time(&end);

	// show performance
	printf("\n attempts: %d, time: %d, performance: %f (checks / sec)", dwCount, (end-start), (float)(dwCount *1.0 / (end-start)));

	// suppose OK
	return TRUE;
}

int main(int argc, char **argv)
{
	// set variables
	if (!init_variables(argc, argv))
	{
		return show_help();
	};

	// show what I'll do
	printf("Trying to switch user to \"%s\" on \"%s\" identified by \"%s\" ... ", lpszUserName, lpszDomainName, lpszPassword);

	// run the process
	int r = run_it();

	// clear memory
	clear_memory();

	// default return value
	return r;
}